import math
class Point:
    def __init__ (self, x, y):
        self.x = x
        self.y = y
        self.numPoint = 2
        
    def sum_squares (self, otherPoint):
        return (self.x - otherPoint.getX())**2 + (self.y - otherPoint.getY())**2
    
    def distance_to (self, otherPoint):
        # using distance formula: sqrt((x2-x1)^2 + (y2-y1)^2)
        return math.sqrt( self.sum_squares(otherPoint) )

    # Python calls this method if you try to print a Point
    def __str__ (self):
        return "({},{})".format(self.x, self.y)

    def getNumPoint(self):
        return self.numPoint

    def getX (self):
        return self.x
    
    def getY (self):
        return self.y

class Point3D (Point):
    def __init__ (self, x, y, z):
        super().__init__(x,y)
        self.z = z
        self.numPoint = 3

    def sum_squares (self, otherPoint3D):
        return super().sum_squares(otherPoint3D) + (self.z - otherPoint3D.getZ())**2

    def __str__ (self):
        return "({},{},{})".format(self.x, self.y, self.z)

    def getZ (self):
        return self.z
                
## IMPORTANT TESTING 

p1 = Point(0,0)
p2 = Point(4,4)
d = p1.distance_to( p2 )
print("distance from", p1, "to", p2, "=", d)
print("NP2:", p1.getNumPoint())

# distance should be 4*sqrt(2) = 5.66
assert round(d,2) == 5.66

p3 = Point3D(0,0,0)
p4 = Point3D(4,4,4)
d = p3.distance_to( p4)
print("distance from", p3, "to", p4, "=", d)
print("NP3:", p3.getNumPoint())

# distance should be sqrt( 4^2 + 4^2 + 4^2 ) = sqrt(48) = 6.93
assert round(d,2) == 6.93
print("Everything is working!")




    
